import { AffixFonts, BarcodeStampOptions, BarcodeType, CssMediaType, CustomPaperSize, FitToPaperModes, HorizontalAlignment, HtmlStampOptions, ImageBehavior, ImageStampOptions, Length, MeasurementUnit, PageInfo, PdfPageSelection, PdfPaperOrientation, PdfPaperSize, PdfPassword, TextStampOptions, UseMargins, VerticalAlignment, WaitFor } from "../../../public/types";
import { ChromePdfRenderOptionsP } from "../../generated_proto/ironpdfengineproto/ChromePdfRenderOptionsP";
import { ChromeFitToPaperModesP } from "../../generated_proto/ironpdfengineproto/ChromeFitToPaperModesP";
import { ChromePdfPaperOrientationP } from "../../generated_proto/ironpdfengineproto/ChromePdfPaperOrientationP";
import { ChromePdfCssMediaTypeP } from "../../generated_proto/ironpdfengineproto/ChromePdfCssMediaTypeP";
import { ChromePdfPaperSizeP } from "../../generated_proto/ironpdfengineproto/ChromePdfPaperSizeP";
import { ChromeUseMarginsP } from "../../generated_proto/ironpdfengineproto/ChromeUseMarginsP";
import { ChromeHtmlHeaderFooterP } from "../../generated_proto/ironpdfengineproto/ChromeHtmlHeaderFooterP";
import { ChromeTextHeaderFooterP } from "../../generated_proto/ironpdfengineproto/ChromeTextHeaderFooterP";
import { FontTypeP } from "../../generated_proto/ironpdfengineproto/FontTypeP";
import { ChromeHttpLoginCredentialsP } from "../../generated_proto/ironpdfengineproto/ChromeHttpLoginCredentialsP";
import { PaperSize } from "../../../public/paper";
import { HtmlAffix, TextAffix } from "../../../public/affix";
import { ChromePdfRenderOptions, HttpLoginCredentials } from "../../../public/render";
import { ChromeImageBehaviorP } from "../../generated_proto/ironpdfengineproto/ChromeImageBehaviorP";
import { _ironpdfengineproto_ChromeApplyStampRequestStreamP_InfoP } from "../../generated_proto/ironpdfengineproto/ChromeApplyStampRequestStreamP";
import { LengthP } from "../../generated_proto/ironpdfengineproto/LengthP";
import { MeasurementUnitP } from "../../generated_proto/ironpdfengineproto/MeasurementUnitP";
import { ChromeBarcodeEncodingP } from "../../generated_proto/ironpdfengineproto/ChromeBarcodeEncodingP";
import { VerticalAlignmentP } from "../../generated_proto/ironpdfengineproto/VerticalAlignmentP";
import { HorizontalAlignmentP } from "../../generated_proto/ironpdfengineproto/HorizontalAlignmentP";
export declare function fitToPaperModeToProto(fitToPaperMode: FitToPaperModes): ChromeFitToPaperModesP;
export declare function PdfPaperOrientationToProto(pdfPaperOrientation: PdfPaperOrientation): ChromePdfPaperOrientationP;
export declare function CssMediaTypeToProto(cssMediaType: CssMediaType): ChromePdfCssMediaTypeP;
export declare function httpLoginCredentialsToProto(httpLoginCredentials?: HttpLoginCredentials | undefined): ChromeHttpLoginCredentialsP | null;
interface WaitForDetail {
    type: number;
    timeout: number;
    networkIdleDuration: number;
    numAllowedInFlight: number;
    renderDelayDuration: number;
    htmlElementQueryStr: string;
}
export declare function convertWaitFor(waitFor: WaitFor | undefined): WaitForDetail;
export declare function chromePdfRenderOptionsToProto(renderOption?: ChromePdfRenderOptions | undefined): ChromePdfRenderOptionsP;
export declare function pdfPaperSizeIsCustom(pdfPaperSize: PdfPaperSize): boolean;
export declare function htmlAffixToProto(htmlAffix: HtmlAffix): ChromeHtmlHeaderFooterP;
export declare function textAffixToProto(textAffix: TextAffix): ChromeTextHeaderFooterP;
export declare function fontToProto(affixFonts?: AffixFonts): FontTypeP | undefined;
export declare function useMarginsToProto(useMargins: UseMargins): ChromeUseMarginsP;
export declare function paperSizeToProto(paperSize: PaperSize): ChromePdfPaperSizeP;
export declare function pdfPaperSizeToProto(pdfPaperSize?: PdfPaperSize | undefined): {
    paperSizeP: ChromePdfPaperSizeP;
    widthHeight?: WidthHeight | undefined;
} | undefined;
export declare function imageBehaviorToProto(imageBehavior?: ImageBehavior | undefined): ChromeImageBehaviorP | null;
export declare function customPaperSizeToMm(customPaperSize: CustomPaperSize): WidthHeight;
export declare type WidthHeight = {
    width: number;
    height: number;
};
export declare function HtmlStampOptionsToProto(id: string, pagesInfo: PageInfo[], password?: PdfPassword | undefined, options?: HtmlStampOptions | undefined, pageSelection?: PdfPageSelection | undefined): _ironpdfengineproto_ChromeApplyStampRequestStreamP_InfoP;
export declare function TextStampOptionsToProto(id: string, pagesInfo: PageInfo[], password?: PdfPassword | undefined, options?: TextStampOptions | undefined, pageSelection?: PdfPageSelection | undefined): _ironpdfengineproto_ChromeApplyStampRequestStreamP_InfoP;
export declare function ImageStampOptionsToProto(id: string, pagesInfo: PageInfo[], password?: PdfPassword | undefined, options?: ImageStampOptions | undefined, pageSelection?: PdfPageSelection | undefined): _ironpdfengineproto_ChromeApplyStampRequestStreamP_InfoP;
export declare function BarcodeStampOptionsToProto(id: string, pagesInfo: PageInfo[], password?: PdfPassword | undefined, options?: BarcodeStampOptions | undefined, pageSelection?: PdfPageSelection | undefined): _ironpdfengineproto_ChromeApplyStampRequestStreamP_InfoP;
export declare function lengthToProto(length?: Length): LengthP | null;
export declare function measurementUnitToProto(measurementUnit: MeasurementUnit): MeasurementUnitP;
export declare function horizontalAlignmentToProto(horizontalAlignment?: HorizontalAlignment | undefined): HorizontalAlignmentP | null;
export declare function verticalAlignmentToProto(verticalAlignment?: VerticalAlignment | undefined): VerticalAlignmentP | null;
export declare function cssMediaTypeToProto(cssMediaType?: CssMediaType | undefined): ChromePdfCssMediaTypeP | null;
export declare function barcodeTypeToProto(barcodeType?: BarcodeType | undefined): ChromeBarcodeEncodingP | null;
export {};
//# sourceMappingURL=converter.d.ts.map