import { Buffer } from "buffer";
import {PdfDocument} from "../public/pdfDocument";

/** @internal */
export type PdfInputType =
	| { type: "htmlString"; htmlString: string }
	| { type: "htmlFile"; htmlFile: string }
	| { type: "pdfFile"; pdfFile: string }
	| { type: "zipFile"; zipFile: string }
	| { type: "buffer"; buffer: Buffer }
	| { type: "url"; url: URL }
	| { type: "pdfDocument"; pdfDocument: PdfDocument };

/** @internal */
export type ImageInput =
	| { type: "imageFilePath"; imageFilePath: string }
	| { type: "imageBuffer"; imageBuffer: Buffer };
