import { z } from "zod"

import {
	pdfPaperSizeSchema
} from "./paperSchema";

import {
	ImageType,
	ImageBehavior, ImageToPdfOptions
} from "../../public/image";
export const imageTypeSchema : z.ZodType<ImageType>  = z.nativeEnum(ImageType)

export const imageBehaviorSchema: z.ZodType<ImageBehavior> = z.nativeEnum(ImageBehavior)

export const imageToPdfOptionsSchema: z.ZodType<ImageToPdfOptions> = z.object({
	imageBehavior: imageBehaviorSchema,
	paperSize: pdfPaperSizeSchema
})
