import {z} from "zod"
import {IronPdfConfig} from "../../public/types";
import {chromeGpuModesSchema} from "./typeSchema";

export const ironPdfConfigSchema: z.ZodType<IronPdfConfig> = z.object({
	ironPdfEngineAddress: z
		.string()
		.optional(),
	ironPdfEngineDockerAddress: z
		.string()
		.optional(),
	debugMode: z
		.boolean()
		.optional(),
	licenseKey: z
		.string()
		.optional(),
	singleProcess: z
		.boolean()
		.optional(),
	chromeBrowserLimit: z
		.number()
		.optional(),
	chromeBrowserCachePath: z
		.string()
		.optional(),
	chromeGpuMode: chromeGpuModesSchema
		.optional(),
	autoInstallDependency: z
		.boolean()
		.optional()
})
