import { z } from "zod"
import {PageInfo, PageRotation} from "../../public/page";

export const pageRotationSchema: z.ZodType<PageRotation> = z.union([
	z.literal(0),
	z.literal(90),
	z.literal(180),
	z.literal(270)
])

export const pageInfoSchema: z.ZodType<PageInfo> = z.object({
	millimeterWidth: z.number(),
	millimeterHeight: z.number(),
	printerPointWidth: z.number(),
	printerPointHeight: z.number(),
	pageRotation: pageRotationSchema
})
