"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pdfPaperSizeSchema = exports.customPaperSizeSchema = exports.paperSizeUnitSchema = exports.pdfPaperOrientationSchema = exports.paperSizeSchema = void 0;
const zod_1 = require("zod");
const paper_1 = require("../../public/paper");
exports.paperSizeSchema = zod_1.z.nativeEnum(paper_1.PaperSize);
exports.pdfPaperOrientationSchema = zod_1.z.nativeEnum(paper_1.PdfPaperOrientation);
exports.paperSizeUnitSchema = zod_1.z.nativeEnum(paper_1.PaperSizeUnit);
exports.customPaperSizeSchema = zod_1.z.object({
    width: zod_1.z.number(),
    height: zod_1.z.number(),
    unit: exports.paperSizeUnitSchema
});
exports.pdfPaperSizeSchema = zod_1.z.union([
    exports.paperSizeSchema,
    exports.customPaperSizeSchema
]);
//# sourceMappingURL=paperSchema.js.map