/// <reference types="node" />
import { z } from "zod";
import { HorizontalAlignment, VerticalAlignment, CssMediaType, FitToPaperModes, MeasurementUnit, UseMargins, ChromeGpuModes, ChangeTrackingModes, HtmlString, HtmlFilePath, ZipFilePath, PdfFilePath, UrlString, BarcodeType, PdfPageSelection, SaveOptions, Length, CropRectangle, MarginConfig, ImageFilePath, ImageBuffer, PdfPassword, PdfInput } from "../../public/types";
import { Buffer } from "buffer";
export declare const horizontalAlignmentSchema: z.ZodType<HorizontalAlignment>;
export declare const verticalAlignmentSchema: z.ZodType<VerticalAlignment>;
export declare const cssMediaTypeSchema: z.ZodType<CssMediaType>;
export declare const fitToPaperModesSchema: z.ZodType<FitToPaperModes>;
export declare const pdfPageSelectionSchema: z.ZodType<PdfPageSelection>;
export declare const measurementUnitSchema: z.ZodType<MeasurementUnit>;
export declare const saveOptionsSchema: z.ZodType<SaveOptions>;
export declare const lengthSchema: z.ZodType<Length>;
export declare const cropRectangleSchema: z.ZodType<CropRectangle>;
export declare const marginConfigSchema: z.ZodType<MarginConfig>;
export declare const filePathSchema: z.ZodType<string>;
export declare const pdfFilePathSchema: z.ZodType<PdfFilePath>;
export declare const zipFilePathSchema: z.ZodType<ZipFilePath>;
export declare const htmlStringSchema: z.ZodType<HtmlString>;
export declare const htmlFilePathSchema: z.ZodType<HtmlFilePath>;
export declare const urlStringSchema: z.ZodType<UrlString>;
export declare const stringSchema: z.ZodType<string>;
export declare const urlSchema: z.ZodType<URL>;
export declare const imageFilePathSchema: z.ZodType<ImageFilePath>;
export declare const bufferSchema: z.ZodType<Buffer>;
export declare const imageBufferSchema: z.ZodType<ImageBuffer>;
export declare const useMarginsSchema: z.ZodType<UseMargins>;
export declare const pdfPasswordSchema: z.ZodType<PdfPassword>;
export declare const chromeGpuModesSchema: z.ZodType<ChromeGpuModes>;
export declare const changeTrackingModesSchema: z.ZodType<ChangeTrackingModes>;
export declare const pdfInputSchema: z.ZodType<PdfInput>;
export declare const dateSchema: z.ZodType<Date>;
export declare const barcodeTypeSchema: z.ZodType<BarcodeType>;
export declare const stringArraySchema: z.ZodType<string[]>;
export declare const bufferArraySchema: z.ZodType<Buffer[]>;
export declare const numberSchema: z.ZodType<number>;
export declare const booleanSchema: z.ZodType<boolean>;
export declare const mapStringSchema: z.ZodType<Map<string, string>>;
//# sourceMappingURL=typeSchema.d.ts.map