/**
 * An interface which represents one page of a PDF Document.
 */
export interface PageInfo {
    /**
     * Width of the pdf page in mm.
     */
    millimeterWidth: number;
    /**
     * Height of the pdf page in mm.
     */
    millimeterHeight: number;
    /**
     * Width of the pdf page in printer points.
     */
    printerPointWidth: number;
    /**
     * Height of the pdf page  in printer points.
     */
    printerPointHeight: number;
    /**
     * Page rotation degree see {@link PageRotation}
     */
    pageRotation: PageRotation;
}
/**
 * PageRotation setting of a PDF page
 */
export declare type PageRotation = 0 | 90 | 180 | 270;
//# sourceMappingURL=page.d.ts.map